var orderPlanSelectedIndex = 0;
var manufacturing_Order_number = undefined;
var customer_order_plan_id = undefined;
var order_id = undefined;

$(document).ready(function () {
    $('#selcPurchaseOrder').on('change', function (event) {
        //$('#inpManuOrderNum').val($(this).find(":selected").text());
        getFactoryPO($(this).val());

    });

    $('#ProductOrderTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            //{ "data": "start_date" },
            //{ "data": "end_date" },
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "status", className: "status" },
            { "data": "edit", className: "action" },
            { "data": "view", className: "action" },
            { "data": "delete", className: "action" },

            // { "data": "status"},
            // { "data": "action" },

        ],
        columnDefs: [
            { width: 100, targets: 0 },
            { width: 50, targets: 2 },
            { width: 50, targets: 3 },
            { width: 50, targets: 4 },
            { width: 50, targets: 5 },
            { width: 50, targets: 6 },
        ],
    });

    var orderPlanTable = $('#OrderPlanTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "id" },
            //{ "data": "customer_order_plan_id" },
            { "data": "manufacturing_Order_number" },
            { "data": "order_id" },
            { "data": "trans_date" },
            { "data": "delivery_date" },
            /*{ "data": "quantity" },
            { "data": "from_date" },
            { "data": "to_date" },*/
            { "data": "description" },
            { "data": "edit", className: "action" },
            { "data": "view", className: "action" },
            { "data": "delete", className: "action" },


        ],
        columnDefs: [
            { width: 100, targets: 0, "visible": false },

        ],
    });
    allSettings();
    allOrderPlan();



    //Reset form
    $('#btnCancelAddOrder').on('click', function () {
        $('#OrderPlanForm').trigger("reset");
        $('#addOrderModal').modal('toggle');
        $('#btnSaveAddOrder').show();
        $('#btnSaveAddOrder').text("Save");

    });


    $('#btnCancelAddProductOrder').on('click', function () {
        $('#OrderPlanDataForm').trigger("reset");
        $('#addProductOrderModal').modal('toggle');
        $('#btnSaveAddProductOrder').show();
        $('#btnSaveAddProductOrder').text("Save");
    });





    $('#OrderPlanTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            orderPlanTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = orderPlanTable.row(this).data();
            manufacturing_Order_number = rowData.manufacturing_Order_number;
            customer_order_plan_id = rowData.customer_order_plan_id;
            getOrderPlanData(customer_order_plan_id);
            order_id = rowData.id;



        }
    });


    /**
    * datepicker
    * This is jquery foe datepicker .
    */
    $('input[name="dteDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });


    $('input[name="dteFromDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });

    $('input[name="dteToDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        autoUpdateInput: false
    }).on('apply.daterangepicker', function (ev, picker) {
        $(this).val(picker.startDate.format('YYYY-MM-DD'));
    });




    let today = new Date().toISOString().substr(0, 10);
    document.querySelector("#dteDate").value = today;




    /**
      * Save add order
      * This function is used to save header order data.
      */
    $('#btnSaveAddOrder').click(function (event) {
        event.preventDefault();
        var form = $('#OrderPlanForm').get(0);
        console.log(form);
        var data = new FormData(form);

        if ($('#btnSaveAddOrder').text() == "Save") {
            if (isRequiredInputsSave().isRequired) {
                if (!isManufacturingOrderNo($('#inpManuOrderNum').val())) {
                    save(data);
                    $('#addOrderModal').modal('toggle');
                } else {
                    showWarningMessage('Allready exist Manufacturing Number :' + $('#inpManuOrderNum').val());
                }
            }
            allOrderPlan();

        } else if ($('#btnSaveAddOrder').text() == "Update") {
            if (isRequiredInputs()) {
                updateOrder();
                $('#addOrderModal').modal('toggle');
            }
            allOrderPlan();



        }

    });


    /**
      * Save order data
      * This function is used to save order data.
      */

    $('#btnSaveAddProductOrder').click(function (event) {
        event.preventDefault();



        if ($('#txtProductID').val() == '') {
            showWarningMessage("Please enter product id...!");
            return;
        }

        if ($('#txtProductName').val() == '') {
            showWarningMessage("Please enter product name...!");
            return;
        }


        if ($('#txtQuantity').val() == '') {
            showWarningMessage("Please enter quantity...!");
            return;
        }

        var orderQty = getOrderQuantity($('#cmbProductCode').val());
        var planQty = getOrderPlanQuantity($('#cmbProductCode').val());
        var qty = $('#txtQuantity').val();

        var orderPlanQty = parseFloat(planQty) + parseFloat(qty);

        if (parseFloat(orderQty) < parseFloat(orderPlanQty)) {
            showAlert("You enterd quantity is graterthan order quantity...!", "Order Quantity : " + orderQty + " Quantity :" + orderPlanQty);
        } else {
            saveAddProductToOrder();
            updateAddProductToOrder();
        }





    });


    //Ajax call for Auto complete product Name Field.
    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/searchPName',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtProductName").setData(response['name']);
                $("#txtProductID").setData(response['id']);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });





    $('#cmbProductCode').on('change', function () {
        getQuantity($(this).val());
    });

});


//function by nipuna start
function showModelAddOrder() {

    loadAllOrder();
    getFactoryPO($('#selcPurchaseOrder').val());
    $('#OrderPlanForm').trigger("reset");
    $('#btnSaveAddOrder').show();
    $('#btnSaveAddOrder').text('Save');
    $('#inpManuOrderNum').val($('#selcPurchaseOrder').find(":selected").text());

    $('#dteDate').daterangepicker({
        singleDatePicker: true,
        defaultDate: new Date(),
        locale: {
            format: 'YYYY-MM-DD'
        }
    });
    $('#dteFromDate').daterangepicker({
        singleDatePicker: true,
        defaultDate: new Date(),
        locale: {
            format: 'YYYY-MM-DD'
        }
    });
    $('#dteToDate').daterangepicker({
        singleDatePicker: true,
        defaultDate: new Date(),
        locale: {
            format: 'YYYY-MM-DD'
        }
    });
    $('#addOrderModal').modal('toggle');
}
//function by nipuna end
function loadAllOrder() {
    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/addOrder/all',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    var order = value.purchase_order + " (" + value.factory_po_num + ")";
                    html += '<option value="' + value.order_id + '">' + order + '</option>';
                    //console.log(html);
                })
                $('#selcPurchaseOrder').html(html);

            } else {

                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });
}

function showModelAddProductToOrder() {
    if (manufacturing_Order_number == undefined) {
        showWarningMessage('Please select a Manufacturing order..!')
        return;
    }
    $('#txtManufacturingOrderNo').val(manufacturing_Order_number + "-");
    loadProductCode();
    $('#btnSaveAddProductOrder').text('Save');
    $('#addProductOrderModal').modal('toggle');
}






/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}



function productQuantity() {

    var order_data_id = $('#selcProduct').val();
    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/productQuantity/" + order_data_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var array = [];
            array = response.data.result
            console.log(array[0]);
            // console.log(response);
            if (response) {


                $('#inpQuantity').val(array[0].quantity_pieces);
                $('#hidProduct').val(order_data_id);
                // val =$('#hidProduct').val();
                // console.log(val)
            } else {

                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {
        }
    });
}

//nipuna ends

/**
* allSettings
* This function is used to load all settings.
*/
function allSettings() {
    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/settings",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var result = response.data.result;
                appendSettings(result);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


/**
* appendSettings
* This function is used append option to combobox.
* @param collection This is the paramter to combobox elements item
*/
function appendSettings(collection) {

    $('#selcPurchaseOrder').append(' <option value="" disabled selected>Select Purchase Order</option>');
    $.each(collection['PurchaseOrder'], function (index, value) {
        $('#selcPurchaseOrder').append('<option value="' + value['order_id'] + '">' + value['purchase_order'] + '</option>');
    });


}


/**
* save
* This function is used to save customer order.
* @param dara This is the paramter to ajax data
*/
function save(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/customerPlan',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Supply Plan details have been saved successfully...");

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#OrderPlanForm').trigger("reset");
        }

    });
}




/**
* getOrderPlan
* This function is used to get customer order to the list view.
* This is the paramter to ajax data
*/

function allOrderPlan() {

    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/allOrderPlan",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            manufacturing_Order_number = undefined;
            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_id'];
                    order_id = response.data.result[i]['order_id'];
                    var trans_date = response.data.result[i]['trans_date'];
                    var delivery_date = response.data.result[i]['delivery_date'];
                    var from_date = response.data.result[i]['from_date'];
                    var to_date = response.data.result[i]['to_date'];
                    var description = response.data.result[i]['description'];
                    var manufacturing_order_number = response.data.result[i]['manufacturing_order_number'];
                    var purchase_order = response.data.result[i]['purchase_order'];
                    //var quantity_pieces = response.data.result[i]['quantity_pieces'];


                    var string_id = "'" + id + "'";
                    data.push({
                        "id": order_id,
                        "customer_order_plan_id": id,
                        "manufacturing_Order_number": manufacturing_order_number,
                        "order_id": purchase_order,
                        "trans_date": trans_date,
                        "delivery_date": delivery_date,
                        /*"quantity": quantity_pieces,
                        "from_date": from_date,
                        "to_date": to_date,*/
                        "description": description,
                        "edit": '<button class="btn btn-warning btn-edit" onclick="editOrder(' + string_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        "view": '<button class="btn btn-success btn-view" onclick="viewOrder(' + string_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        "delete": '<button class="btn btn-danger btn-delete" onclick="deleteOrder(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',

                    });
                }


                var table = $('#OrderPlanTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}


/**
* getOrderPlanData
* This function is used to get customer order data to the list view.
* This is the paramter to ajax data
*/
function getOrderPlanData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/customerPlanData/allOrderPlanData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                var disable = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['customer_order_plan_data_id'];
                    //var start_date = response.data.result[i]['start_date'];
                    //var end_date = response.data.result[i]['end_date'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var string_id = "'" + id + "'";
                    data.push({
                        "customer_order_plan_data_id": id,
                        //"start_date": start_date,
                        //"end_date": end_date,
                        "product_id": product_id,
                        "product_name": product_name,
                        "quantity": quantity,
                        "status": '<label class="switch ml-4"><input type="checkbox" id="' + response.data.result[i].customer_order_plan_data_id + '" onchange="disable(event,' + "'CustomerPlanData'" + ')" ' + disable[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "edit": '<button class="btn btn-warning btn-edit" onclick="editProductToOrder(' + string_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        "view": '<button class="btn btn-success btn-view" onclick="viewProductToOrder(' + string_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        "delete": '<button class="btn btn-danger btn-delete" onclick="deleteProductToOrder(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',

                    });
                }


                var table = $('#ProductOrderTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}




/**
* updatePlan
* This function is used to update customer order plan.
* @param data This is the paramter to ajax data
*/
function updatePlan(data) {
    console.log(data);
    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/customerPlan/update/',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("customer order data record has been updated successfully...");

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#OrderPlanForm').trigger("reset");
            $('#btnSaveAddOrder').text("Save");
        }

    });
}

/**
* updateOrderData
* This function is used to update customer order plan data.
* @param data This is the paramter to ajax data
*/
function updateOrderData(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/customerPlanData/update',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Customer order plan data record has been updated successfully...");

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#OrderPlanDataForm').trigger("reset");
            $('#btnSaveAddProductOrder').text("Save");

        }

    });
}


/**
* getName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getProductName() {
    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/getPName/' + $('#txtProductName').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response) {
                $('#txtProductID').val(response.product_id);

            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}


/**
* disabled
* This function is used to update settings.
* @param url This is the paramter to ajax request url
* @param id This is the paramter to ajax data
*/
function _disabled(id, status) {

    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: '/pp/customerPlanData/customerPlanData/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");



            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {
                    //assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");

                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}

/**
* save
* This function is used to disable settings.
* @param event This is the paramter to identifi desable/enable
*/
function disable(event) {
    var id = event.target.id;
    var status = event.target.checked;
    _disabled(id, status);
}



function loadProductCode() {

    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/loadProductCode/' + order_id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            var data = response.data.result;
            document.getElementById("cmbProductCode").options.length = 0;
            $('#cmbProductCode').append('<option selected disabled>-- Select --</option>');
            for (var i = 0; i < data.length; i++) {

                $('#cmbProductCode').append('<option value="' + data[i].order_data_id + '">' + data[i].product_name + '</option>');
            }

        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });
}


function getOrderQuantity(productCodeID) {


    var quantity = 0;
    $.ajax({
        type: "GET",
        url: '/pp/customerPlan/orderQuantity/' + productCodeID,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            quantity = response.data.result;
        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });

    return quantity;
}





function getOrderPlanQuantity(orderDataID) {


    var quantity = 0;
    $.ajax({
        type: "GET",
        url: '/pp/customerPlan/orderPlanQuantity/' + orderDataID,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            quantity = response.data.result.quantity;
            if (!quantity) {
                quantity = 0;
            }
        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });

    return quantity;
}





function showAlert(title, message) {
    swal({
        title: title,
        text: message,
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $('.swal-button').on('click', function (event) {
        if ($(this).text() == 'OK') {
            saveAddProductToOrder();
            updateAddProductToOrder();
        }
    });

}


function saveAddProductToOrder() {

    if ($('#btnSaveAddProductOrder').text() == 'Save') {

        if (isAddProductToOrder(customer_order_plan_id, $('#cmbProductCode').val())) {
            showWarningMessage($('#cmbProductCode option:selected').text() + " Already addedd.");
            return;
        }

        var form = $('#OrderPlanDataForm').get(0);
        var data = new FormData(form);
        data.append('order_id', order_id);
        data.append('customerOrderPlanID', customer_order_plan_id);
        data.append('product_primary_id', $('#txtProductName').optionID());


        $.ajax({
            type: "POST",
            enctype: 'multipart/form-data',
            url: '/pp/customerPlanData/saveAddProductToOrder',
            data: data,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                if (response.data.success) {

                    showSuccessMessage("Customer order plan data record has been saved successfully...");

                } else {
                    showErrorMessage();
                }


            },
            error: function (error) {
                console.log(error);
                showErrorMessage();

            },
            complete: function () {
                $('#OrderPlanDataForm').trigger("reset");
                $('#btnSaveAddProductOrder').text("Save");
                $('#addProductOrderModal').modal('hide');
                getOrderPlanData(customer_order_plan_id);

            }

        });
    }
}





function updateAddProductToOrder() {

    if ($('#btnSaveAddProductOrder').text() == 'Update') {
        var form = $('#OrderPlanDataForm').get(0);
        var data = new FormData(form);
        data.append('customerOrderPlanID', customer_order_plan_id);
        data.append('product_primary_id', $('#txtProductName').optionID());


        $.ajax({
            type: "POST",
            enctype: 'multipart/form-data',
            url: '/pp/customerPlanData/updateAddProductToOrder/' + $('#txtHidCustomerOrderPlanDataID').val(),
            data: data,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                if (response.data.success) {

                    showSuccessMessage("Customer order plan data record has been updated successfully...");

                } else {
                    showErrorMessage();
                }


            },
            error: function (error) {
                console.log(error);
                showErrorMessage();

            },
            complete: function () {
                $('#OrderPlanDataForm').trigger("reset");
                $('#btnSaveAddProductOrder').text("Save");
                $('#addProductOrderModal').modal('hide');
                getOrderPlanData(customer_order_plan_id);

            }

        });
    }
}



function editProductToOrder(id) {
    getProductToOrder(id);
    $('#btnSaveAddProductOrder').text('Update');
}


function viewProductToOrder(id) {
    getProductToOrder(id);
    $('#btnSaveAddProductOrder').hide();
}



function deleteProductToOrder(id) {

    $.ajax({
        type: 'DELETE',
        url: '/pp/customerPlanData/deleteProductToOrder/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (response.data.result.message == 'warning') {
                    showWarningMessage('You cannot delete this order :' + response.data.result.msg);
                } else if (response.data.result.message == 'success') {
                    showSuccessMessage("Customer order plan data has been deleted successfully....")
                }
                getOrderPlanData(customer_order_plan_id);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}




function getProductToOrder(id) {
    loadProductCode();
   
    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/getProductToOrder/' + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var planData = response.data.result;
                $('#txtHidCustomerOrderPlanDataID').val(planData.customer_order_plan_data_id);
                $('#txtManufacturingOrderNo').val(planData.manufacturing_order_no + "-");
                $('#txtManufacturingOrderConcatNo').val(planData.manufacturing_order_concat_no);
                setSelectedOption('cmbProductCode', planData.order_data_id);
                $('#txtProductID').val(planData.product_id);
                $('#txtProductID').attr('data-id', planData.product_id);
                $('#txtProductName').val(planData.product_name);
                $('#txtProductName').attr('data-id', planData.product_id);

                $('#txtQuantity').val(planData.quantity);

            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
            $('#addProductOrderModal').modal('toggle');
        }
    });
}





function editOrder(id) {
    getOrder(id);
    $('#btnSaveAddOrder').text('Update');
}


function viewOrder(id) {
    getOrder(id);
    $('#btnSaveAddOrder').hide();
}



function deleteOrder(id) {

    $.ajax({
        type: 'DELETE',
        url: '/pp/customerPlan/deleteOrder/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                if (response.data.result.message == 'warning') {
                    showWarningMessage('You cannot delete this order :' + response.data.result.order);
                } else if (response.data.result.message == 'success') {
                    showSuccessMessage("Customer Order Plan has been deleted successfully...");
                }

                allOrderPlan();
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}





function getOrder(id) {
    loadAllOrder();
    $.ajax({
        type: 'GET',
        url: '/pp/customerPlanData/getOrder/' + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var orderData = response.data.result;
                $('#hidOrderPlanID').val(orderData.customer_order_plan_id);
                setSelectedOption('selcPurchaseOrder', orderData.order_id);
                $('#inpManuOrderNum').val(orderData.manufacturing_order_number);

                $('#dteDate').val(orderData.trans_date);
                $('#dteDate').daterangepicker({
                    singleDatePicker: true,
                    defaultDate: orderData.trans_date,
                    locale: {
                        format: 'YYYY-MM-DD'
                    }
                });
                $('#dteFromDate').val(orderData.from_date);
                $('#dteFromDate').daterangepicker({
                    singleDatePicker: true,
                    defaultDate: orderData.from_date,
                    locale: {
                        format: 'YYYY-MM-DD'
                    }
                });
                $('#dteToDate').val(orderData.to_date);
                $('#dteToDate').daterangepicker({
                    singleDatePicker: true,
                    defaultDate: orderData.to_date,
                    locale: {
                        format: 'YYYY-MM-DD'
                    }
                });
                $('#txtDescription').val(orderData.description);

            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
            $('#addOrderModal').modal('toggle');
        }
    });
}





function updateOrder() {

    if ($('#btnSaveAddOrder').text() == 'Update') {
        var form = $('#OrderPlanForm').get(0);
        var data = new FormData(form);


        $.ajax({
            type: "POST",
            enctype: 'multipart/form-data',
            url: '/pp/customerPlanData/updateOrder/' + $('#hidOrderPlanID').val(),
            data: data,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                if (response.data.success) {

                    showSuccessMessage("Customer order plan data record has been updated successfully...");

                } else {
                    showErrorMessage();
                }


            },
            error: function (error) {
                console.log(error);
                showErrorMessage();

            },
            complete: function () {
                $('#OrderPlanDataForm').trigger("reset");
                $('#btnSaveAddProductOrder').text("Save");
                $('#addProductOrderModal').modal('hide');
                getOrderPlanData(customer_order_plan_id);

            }

        });
    }
}



function isManufacturingOrderNo(orderNo) {
    var bool = false;
    $.ajax({
        type: "GET",
        url: '/pp/customerPlan/isManufacturingOrderNo/' + orderNo,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            bool = response.data.result;
        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });

    return bool;
}


function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}



function getQuantity(id) {
    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/getQuantity/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            var qty = response.data.result;
            $('#txtQuantity').val(qty.replace(/\$|,/g, ''));

        },
        error: function (error) {
            console.log(error);

        },

    });
}



function getFactoryPO(id) {
    $.ajax({
        type: "GET",
        url: "/pp/customerPlan/getFactoryPO/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            $('#inpManuOrderNum').val(response.data.result);

        },
        error: function (error) {
            console.log(error);

        },

    });

}



function isAddProductToOrder(order_id, product_id) {
    var bool = false;
    $.ajax({
        type: "GET",
        url: '/pp/customerPlan/isAddProductToOrder/' + order_id + "/" + product_id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            bool = response.data.result;
        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });

    return bool;
}

